/******************************************************
Demo Anwendung fuer:
TLC5940: 16 Channel LED Driver w/DOT Correction & Grayscale PWM Control
http://focus.ti.com/docs/prod/folders/print/tlc5940.html

realesed under the GPL by Philipp Tiefenbacher
******************************************************/
#include "18f458.h"
//#include "16f877.h"

#device ADC=10
#include <STDLIB.H>
#include <math.h>
#fuses hs,nowdt,put,noprotect
#use delay(clock=20000000)	//20MHz, fuer delay()


// Names of the Input Pins of the LED Driver according to the datasheet
#define VPRG  PIN_D1  //27
#define SIN_PIN   PIN_D2  //26 in the DIP package
#define SCLK  PIN_D3  //25
#define XLAT  PIN_D4  //24
#define BLANK PIN_D5  //23
#define DCPRG PIN_D6  //19
#define GSCLK PIN_D7  //18

#define CHANNELS 64 // set this to a multiple of 16 if you cascade more than one TLC5940

#include "TLC5940.h"

#use rs232(baud=57600, xmit=PIN_C6, rcv=PIN_C7, Errors)


#define PHONE_GREEN_0 0
#define PHONE_GREEN_1 1
#define PHONE_GREEN_2 2
#define PHONE_GREEN_3 3

#define ATOM_RED_0 4
#define ATOM_RED_1 5
#define ATOM_RED_2 6
#define ATOM_RED_3 7
#define ATOM_RED_4 8
#define ATOM_RED_5 9

#define PHONE_BLUE_0 10
#define PHONE_BLUE_1 11
#define PHONE_BLUE_2 12

#define CHANGE 5

void main ()
{
   long i, j, count, count2;
   int start, gray, delay;
   int now[CHANNELS], future[CHANNELS], blink[CHANNELS], blink_count[CHANNELS];
   int color, index;
   int key;

   initTLC5940();

   count = 0;
   count2 = 10;
   color = 0;
   delay = 1;

   for (i=0; i < CHANNELS; i++) {
         dcs[i]=0;
         now[i] = 0;
         future[i] = 0;
         blink[i] = 0;
         blink_count[i] = 0;
   }
   
	while (1) {    
      count++;
      if (count >= 64) {
         for (i=0; i < CHANNELS; i++) {
            now[i] = future[i];
         }
         delay = rand() % 40; + 10;
         for (j = 0; j < 2; j++) {
            start = rand()%(CHANNELS-CHANGE+1);
            gray = rand() % 64;
            for (i = start; i < start+CHANGE; i++) {
               future[i] = gray;
            }
            
            start = rand()%(CHANNELS-CHANGE+1);
            gray = (rand() % 30) + 8;
            for (i = start; i < start+CHANGE; i++) {
               //blink[i] = gray;
            }
            
            start = rand()%(CHANNELS-CHANGE+1);
            for (i = start; i < start+CHANGE; i++) {
               future[i] = 0;
            }
         }

         count = 0;
         count2--;
         if (count2 == 0) {
            for (i = 0; i < CHANNELS; i++) {
               future[i] = 0;
               blink[i] = 0;
            }
            count2 = 10 + rand()%60;
         }
      }
      
      for (i = 0; i < CHANNELS; i++) {
         if (blink[i] != 0 && blink_count[i] < blink[i]/2) {
            dcs[i] = 0;
         }
         else{
            dcs[i] = (now[i]*(64l-count)+future[i]*count)/64l;
         }
         if (blink[i] != 0) {
            blink_count[i]++;
            if (blink_count[i] >= blink[i]) {
               blink_count[i] = 0;
            }
         }
      }
      
      if (kbhit()) {
         getch();
         puts("comander?");
      }

      refreshDisplay();
      delay_ms(20);
	}
}
