/******************************************************
Demo Anwendung fuer:
TLC5940: 16 Channel LED Driver w/DOT Correction & Grayscale PWM Control
http://focus.ti.com/docs/prod/folders/print/tlc5940.html

realesed under the GPL by Philipp Tiefenbacher
******************************************************/
#include "18f458.h"
//#include "16f877.h"

#device ADC=10
#include <STDLIB.H>
#include <math.h>
#fuses hs,nowdt,put,noprotect
#use delay(clock=20000000)	//20MHz, fuer delay()


// Names of the Input Pins of the LED Driver according to the datasheet
#define VPRG  PIN_D1  //27
#define SIN_PIN   PIN_D2  //26 in the DIP package
#define SCLK  PIN_D3  //25
#define XLAT  PIN_D4  //24
#define BLANK PIN_D5  //23
#define DCPRG PIN_D6  //19
#define GSCLK PIN_D7  //18

#define CHANNELS 64 // set this to a multiple of 16 if you cascade more than one TLC5940

#include "TLC5940.h"

#use rs232(baud=19200, xmit=PIN_C6, rcv=PIN_C7, Errors)


#define PHONE_GREEN_0 0
#define PHONE_GREEN_1 1
#define PHONE_GREEN_2 2
#define PHONE_GREEN_3 3

#define ATOM_RED_0 4
#define ATOM_RED_1 5
#define ATOM_RED_2 6
#define ATOM_RED_3 7
#define ATOM_RED_4 8
#define ATOM_RED_5 9

#define PHONE_BLUE_0 10
#define PHONE_BLUE_1 11
#define PHONE_BLUE_2 12





int current_step;






void all_on(int color_offset, long brightness) {
   int i;
  //red alle ein  und lansam abdunkeln
   for (i = 0; i <16; i++) {
      dcs[color_offset + i] =  brightness;
   }

}



  
int rotate_color(int color_offset, int rotate_offset)
{
  int i;
  int beforeoffset;
  int nextoffset;
    
  for (i = 0; i <16; i++) {
      dcs[color_offset + i] =  0;
  }

   beforeoffset= (rotate_offset-1);
   if (beforeoffset<0){ beforeoffset=15; }

   nextoffset= (rotate_offset+1); 
   if(nextoffset>15){ nextoffset=0;}


  dcs[color_offset + beforeoffset] =  10;
  dcs[color_offset + rotate_offset] =  63;
  dcs[color_offset + nextoffset+1] =  10;

 rotate_offset = rotate_offset+1; 

 if(rotate_offset >15)
   rotate_offset=0;
 
 return rotate_offset;
}








int flash_color(int color_offset,int flash_offset)
{

  int i;

  for (i = 0; i <16; i++) {
      dcs[color_offset + i] =  flash_offset;
  }

 flash_offset++; 

 if(flash_offset >63)
   flash_offset=0;
 
 return flash_offset;
}




#define RED 16
#define GREEN 32
#define BLUE 48

void main ()
{
   int delay=100;
   
   
   
   int flashmode=2;
   
   int flashmode_functions =2; // wiviele flashfunctions haben wir?
   
   
   // flashmode 1  regenbogenverlauf
   int red_rotate_offset = 0;
   int green_rotate_offset = 4;
   int blue_rotate_offset = 8;


   // flashmode 2  colorflash
   int red_flash_offset = 0;
   int green_flash_offset = 20;
   int blue_flash_offset = 40;   
   
   
   
  
   initTLC5940();
   clearDisplay();




 

	while (1) {
      // where am i now?  this is the global thing all function use to determine if the should do something
 /*
      flashmode = rand() / (RAND_MAX/flashmode_functions);
      if (flashmode<1) { flashmode=1}
 */

      if(flashmode == 1)
      {
       // farbverlauf  regenbogen
       red_rotate_offset = rotate_color(RED,red_rotate_offset);
       green_rotate_offset = rotate_color(GREEN,green_rotate_offset);
       blue_rotate_offset = rotate_color(BLUE,blue_rotate_offset);      
      }

      if(flashmode == 2)
      {
       // farbflasher
       red_flash_offset = flash_color(RED,red_flash_offset);
       green_flash_offset = flash_color(GREEN,green_flash_offset);
       blue_flash_offset = flash_color(BLUE,blue_flash_offset);      
      }




      current_step++;      
      delay_ms(delay);      
      refreshDisplay();      

     
/*
      all_on(RED,63);
      refreshDisplay();
      //puts("send!");
      delay_ms(delay);
      clearDisplay();


      all_on(GREEN,63);
      refreshDisplay();
      //puts("send!");
      delay_ms(delay);
      clearDisplay();

      all_on(BLUE,63);
      refreshDisplay();
      //puts("send!");
      delay_ms(delay);
      clearDisplay();

      all_on(0,63);
      refreshDisplay();
      //puts("send!");
      delay_ms(350);
      clearDisplay();
*/
	}
}
