/******************************************************
Demo Anwendung fuer:
TLC5940: 16 Channel LED Driver w/DOT Correction & Grayscale PWM Control
http://focus.ti.com/docs/prod/folders/print/tlc5940.html

realesed under the GPL by Philipp Tiefenbacher
******************************************************/
#include "18f458.h"
//#include "16f877.h"

#device ADC=10
#include <STDLIB.H>
#include <math.h>
#fuses hs,nowdt,put,noprotect
#use delay(clock=20000000)	//20MHz, fuer delay()

#define PIN_CAPMEASURE PIN_C0

#define PIN_CAPMEASURE2_1 PIN_A1
#define PIN_CAPMEASURE2_2 PIN_A2



// Names of the Input Pins of the LED Driver according to the datasheet
#define VPRG  PIN_D1  //27
#define SIN_PIN   PIN_D2  //26 in the DIP package
#define SCLK  PIN_D3  //25
#define XLAT  PIN_D4  //24
#define BLANK PIN_D5  //23
#define DCPRG PIN_D6  //19
#define GSCLK PIN_D7  //18

#define CHANNELS 64 // set this to a multiple of 16 if you cascade more than one TLC5940

#include "TLC5940.h"

#use rs232(baud=19200, xmit=PIN_C6, rcv=PIN_C7, Errors)


#define PHONE_GREEN_0 0
#define PHONE_GREEN_1 1
#define PHONE_GREEN_2 2
#define PHONE_GREEN_3 3

#define ATOM_RED_0 4 
#define ATOM_RED_1 5
#define ATOM_RED_2 6
#define ATOM_RED_3 7
#define ATOM_RED_4 8
#define ATOM_RED_5 9

#define PHONE_BLUE_0 10
#define PHONE_BLUE_1 11
#define PHONE_BLUE_2 12


int atom_state, atom_dir;


void init_metalab() {
   atom_state = 0;
   atom_dir = 1;
}

void step_atom() {
   atom_state += atom_dir;
   
   if (atom_state == 63 || atom_state == 0) {
      atom_dir = -atom_dir;
   }

   dcs[ATOM_RED_0] = atom_state;
   dcs[ATOM_RED_1] = atom_state;
   dcs[ATOM_RED_2] = atom_state;
   dcs[ATOM_RED_3] = atom_state;
   dcs[ATOM_RED_4] = atom_state;
   dcs[ATOM_RED_5] = atom_state;   
}


void main ()
{
   int i, count;

   initTLC5940();

   init_metalab();

   count = 0;

	while (1) {
      for (i = 0; i < CHANNELS; i++) {
         if (i == (count & 63)) {
            dcs[i] = 63;
         }
         else {
            dcs[i] = 0;
         }
      }
      count++;
      step_atom();
      refreshDisplay();
      puts("send!");
      delay_ms(20);
	}
}
